(defun matches-in-string (regexp string)
  "return a list of matches of REGEXP in STRING."
  (let ((matches))
    (save-match-data
      (string-match "^" "")
      (while (string-match regexp string (match-end 0))
        (push (or (match-string 1 string) (match-string 0 string)) matches)))
    matches))

(defun guix-switch-profile (&optional profile)
  "reset Emacs' environment by snarfing PROFILE/etc/profile"
  (interactive "fprofile: ")
  (let* ((output (shell-command-to-string (concat "/bin/sh -x " profile "/etc/profile")))
         (exports (matches-in-string "^[+] export \\(.*\\)" output)))
   (mapcar (lambda (line) (apply #'setenv (split-string line "="))) exports )))
